----------------------------------------------------------------------------------------
-- This code implements a decoder hardware from binary to hexadecimal for a 7-seg display
--
-- Elements of Digital Logic (SCC - 0512) - Institute of Mathematical and Computer Sciences
-- University of Sao Paulo
--
-- Author: Bruno de Abreu Silva
-- e-mail: brunoas@icmc.usp.br
-- Date: 2012/04/09
----------------------------------------------------------------------------------------

library ieee ;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity hexa7seg is
    port(
        bin: in std_logic_vector (3 downto 0); 
        seg: out std_logic_vector (6 downto 0) 
    );
end hexa7seg;

architecture logicFunc of hexa7seg is
begin
    seg(0) <= (bin(0) or bin(1) or bin(2) or not(bin(3))) and 
              (bin(0) or not(bin(1)) or bin(2) or not(bin(3))) and
              (not(bin(0)) or not(bin(1)) or bin(2) or not(bin(3))) and
              (not(bin(0)) or bin(1) or not(bin(2)) or not(bin(3)));

    seg(1) <= (not(bin(0)) or bin(1) or not(bin(2)) or bin(3)) and
              (not(bin(1)) or not(bin(2)) or bin(3)) and
              (not(bin(0)) or not(bin(2)) or not(bin(3))) and
              (not(bin(0)) or not(bin(1)) or bin(3));

    seg(2) <= (bin(0) or bin(1) or not(bin(2)) or bin(3)) and
              (not(bin(0)) or not(bin(1)) or not(bin(2))) and
              (not(bin(0)) or not(bin(1)) or bin(3));

    seg(3) <= (bin(0) or not(bin(1)) or bin(2) or bin(3)) and
              (bin(0) or bin(1) or bin(2) or not(bin(3))) and
              (not(bin(0)) or bin(1) or not(bin(2)) or bin(3)) and
              (not(bin(1)) or not(bin(2)) or not(bin(3)));
    
    seg(4) <= (bin(0) or not(bin(3))) and
              (bin(0) or not(bin(1)) or bin(2)) and
              (bin(1) or bin(2) or not(bin(3)));

    seg(5) <= (not(bin(0)) or not(bin(1)) or bin(2) or not(bin(3))) and
              (bin(0) or bin(1) or not(bin(3))) and
              (bin(0) or not(bin(2)) or not(bin(3))) and
              (bin(0) or bin(1) or not(bin(2)));

    seg(6) <= (bin(0) or bin(1) or bin(2)) and
              (bin(0) or not(bin(1)) or not(bin(2)) or not(bin(3))) and
              (not(bin(0)) or not(bin(1)) or bin(2) or bin(3));
end logicFunc;
